part of masamune;

extension WidgetRefMemoizedExtensions on WidgetRef {
  T useMemoized<T>(
    String key,
    T value, {
    List<Object> keys = const [],
  }) {
    return valueBuilder<T, _MemoizedValue<T>>(
      key: "memoized:$key",
      builder: () {
        return _MemoizedValue<T>(
          value: value,
          keys: keys,
        );
      },
    );
  }
}

@immutable
class _MemoizedValue<T> extends ScopedValue<T> {
  const _MemoizedValue({
    required this.value,
    required this.keys,
  });
  final T value;
  final List<Object> keys;
  @override
  ScopedValueState<T, ScopedValue<T>> createState() => _MemoizedValueState<T>();
}

class _MemoizedValueState<T> extends ScopedValueState<T, _MemoizedValue<T>> {
  late T _value;

  @override
  void initValue() {
    super.initValue();
    _value = value.value;
  }

  @override
  void didUpdateValue(_MemoizedValue<T> oldValue) {
    super.didUpdateValue(oldValue);
    if (value.keys != oldValue.keys) {
      _value = value.value;
    }
  }

  @override
  T build() => _value;
}
